//+------------------------------------------------------------------+
//|                                                  Colored_AMA.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

//---- input parameters
extern int       periodAMA=26;
extern int       nfast=5;
extern int       nslow=20;
extern double    G=2.0;
extern double    dK=2.0; 

//---- buffers
double DrawUpBuffer[];
double DrawDownBuffer[];
double kAMAbuffer[];

//+------------------------------------------------------------------+

int    cbars=0, prevbars=0, prevtime=0;

double slowSC,fastSC;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_LINE,0,2);
   SetIndexStyle(1,DRAW_LINE,0,2);
   //SetIndexDrawBegin(0,nslow+nfast);
   SetIndexBuffer(0,DrawUpBuffer);
   SetIndexBuffer(1,DrawDownBuffer);
   SetIndexBuffer(2,kAMAbuffer);
   
   
   IndicatorDigits(4);
   
   //slowSC=0.064516;
   //fastSC=0.2;
   //cbars=IndicatorCounted();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    i,pos=0;
   double noise=0.000000001,AMA,AMA0,AMAPrev, signal,ER;
   double dSC,ERSC,SSC,ddK;
   int mode = 0;
   
   if (prevbars==Bars) return(0);
    
//---- TODO: add your code here
   slowSC=(2.0 /(nslow+1));
   fastSC=(2.0 /(nfast+1));
   cbars=IndicatorCounted();
   if (Bars<=(periodAMA+2)) return(0);
//---- check for possible errors
   if (cbars<0) return(-1);
//---- last counted bar will be recounted
   if (cbars>0) cbars--;
   pos=Bars-periodAMA-2;
   AMA0=Close[pos+1];
   while (pos>=0)
     {
      if(pos==Bars-periodAMA-2) AMA0=Close[pos+1];
      signal=MathAbs(Close[pos]-Close[pos+periodAMA]);
      noise=0.000000001;
      for(i=0;i<periodAMA;i++)
       {
        noise=noise+MathAbs(Close[pos+i]-Close[pos+i+1]);
       }
      ER =signal/noise;
      dSC=(fastSC-slowSC);
      ERSC=ER*dSC;
      SSC=ERSC+slowSC;
      AMA=AMA0+(MathPow(SSC,G)*(Close[pos]-AMA0));
      kAMAbuffer[pos]=AMA;
      Comment(" buffer[pos] =     ", kAMAbuffer[pos],"\n",
	        " buffer[pos+1] = ", kAMAbuffer[pos + 1]);
      if(kAMAbuffer[pos] > AMAPrev)
      {
         DrawUpBuffer[pos] = AMA;
         DrawDownBuffer[pos] = EMPTY_VALUE;
         mode = 1;
         AMAPrev = AMA;
      }
      
      else if(kAMAbuffer[pos] < AMAPrev)
      {
         DrawDownBuffer[pos] = AMA;
         DrawUpBuffer[pos] = EMPTY_VALUE;
         mode = 2;
         AMAPrev = AMA;
      }
      
      else
      {
         if(mode == 1)
         {
            DrawUpBuffer[pos] = AMA;
            DrawDownBuffer[pos] = EMPTY_VALUE;
         }
         if(mode == 2)
         {
            DrawDownBuffer[pos] = AMA;
            DrawUpBuffer[pos] = EMPTY_VALUE;
         }
         
      }
      ddK=(AMA-AMA0);
     
     
      AMA0=AMA;
      pos--;
     }
//----
   prevbars=Bars;
   return(0);
  }

